unit opengraphicscontrol;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, OpenGLContext;

type

  TGOnInitGL = procedure (self:TObject) of object;
  { TGOpenGLControl }

  TGOpenGLControl = class (TCustomOpenGLControl)
  private
    FGOnInitGL:TGOnInitGL;

  protected
    procedure CreateWnd; override;
  published
    property OnMouseDown;
    property OnMouseEnter;
    property OnMouseLeave;
    property OnMouseMove;
    property OnMouseUp;
    property OnMouseWheel;
    property OnMouseWheelDown;
    property OnMouseWheelUp;
    property OnInitGL:TGOnInitGL read FGOnInitGL write FGOnInitGL;
  end;

procedure Register;
implementation

procedure Register;
begin
  RegisterComponents('Graphica',[TGOpenGLControl]);
end;

{ TGOpenGLControl }

procedure TGOpenGLControl.CreateWnd;
begin
  inherited CreateWnd;
  MakeCurrent();
  if Assigned(FGOnInitGL) then
     FGOnInitGL(Self);
end;


end.

