unit graphica_object;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

type


  TGObject = class
  end;


  { TGObjectChilds }

  TGObjectChilds = class (TGObject)
  private
    function GetChilds(const index:Integer):TGObject;
  protected
    FChilds:TFPList;
    FOnwer:TGObjectChilds;
  public
    constructor Create();
    constructor Create(own:TGObjectChilds);
    destructor Destroy();override;

    procedure Add(const obj:TGObject);virtual;
    procedure Delete(obj:TGObject);virtual;
    procedure Remove(const obj:TGObject);virtual;
    procedure Clear();

    property Childs[index:Integer]:TGObject read GetChilds;
  end;


implementation

{ TGObjectChilds }

function TGObjectChilds.GetChilds(const index: Integer): TGObject;
begin
  Result:=TGObject(FChilds[index])
end;

constructor TGObjectChilds.Create;
begin
  FOnwer:=nil;
  FChilds:=TFPList.Create;
end;

constructor TGObjectChilds.Create(own: TGObjectChilds);
begin
  FChilds:=TFPList.Create;
  if own<>nil then
    own.Add(self);
  FOnwer:=own;
end;

destructor TGObjectChilds.Destroy;
begin
  Clear();
  FreeAndNil(FChilds);
  inherited Destroy;
end;

procedure TGObjectChilds.Add(const obj: TGObject);
var
  objchl:TGObjectChilds;
begin
  FChilds.Add(obj);
  objchl:=(obj as TGObjectChilds);
  if(objchl<>nil) then
    objchl.FOnwer:=self;
end;

procedure TGObjectChilds.Delete(obj: TGObject);
var
  i:Integer;
begin
  i:=FChilds.IndexOf(obj);
  if i<>-1 then begin
    FChilds.Delete(i);
    FreeAndNil(obj);
  end;
end;

procedure TGObjectChilds.Remove(const obj: TGObject);
var
  i:Integer;
begin
  i:=FChilds.IndexOf(obj);
  if i>-1 then
    FChilds.Delete(i);
end;

procedure TGObjectChilds.Clear;
var
  i:Integer;
  obj:TGObject;
begin
  for i:=0 to FChilds.Count-1 do begin
    obj:=TGObject(FChilds[i]);
    FreeAndNil(obj);
  end;
  FChilds.Clear;
end;

end.

