unit graphica_guistyle;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, gl, graphica_glshader;

type

  TGGUIStyleShaderParams = record
    MVP,MMA,MMS,Alpha,Texture:GLuint;
  end;


  { TGGUIStyle }

  TGGUIStyle = class
  private
    FShader:TGGLShader;
    FShaderParams:TGGUIStyleShaderParams;

  public
    constructor Create();
    destructor Destroy();override;

    property Shader:TGGLShader read FShader;
    property ShaderParams:TGGUIStyleShaderParams read FShaderParams;
  end;


implementation
uses glext;

{$i graphica_guivisualcomponents_shader.inc}

{ TGGUIStyle }

constructor TGGUIStyle.Create;
begin
  FShader:=TGGLShader.Create(sVGUITexture,sFGUITexture);
  FShaderParams.MVP:=glGetUniformLocation(FShader.ID,'MVP');
  FShaderParams.MMS:=glGetUniformLocation(FShader.ID,'MMS');
  FShaderParams.MMA:=glGetUniformLocation(FShader.ID,'MA');
  FShaderParams.Alpha:=glGetUniformLocation(FShader.ID,'A');
  FShaderParams.Texture:=glGetUniformLocation(FShader.ID,'tex0');
end;

destructor TGGUIStyle.Destroy;
begin
  FreeAndNil(FShader);
  inherited Destroy;
end;

end.

