function threadPaintPlane(pplane: pointer) : ptrint;
var
  plane:TGGUIPlane;
  image:TLazIntfImage;
  rgba: TRawImageDescription;
  canvas:TFPImageCanvas;
  sizePlane:TGVector3f;
  pr:PGGUIRenderParamsPlane;
  i:Integer;
begin
  pr:=pplane;
  plane:=TGGUIPlane(pr^.GUIObject);
  sizePlane:=plane.GetSize();
  image:=TLazIntfImage.Create(0,0);
  try
    rgba.Init_BPP32_R8G8B8A8_BIO_TTB(0,0);
    image.DataDescription:=rgba;
    image.Width:=trunc(sizePlane[0]);
    image.Height:=trunc(sizePlane[1]);
    canvas:=TFPImageCanvas.create(image);
    canvas.Brush.FPColor:=FPColor($E0FF,$E0FF,$E0FF,$FFFF);
    canvas.Pen.FPColor:=FPColor($FFFF,$FFFF,$FFFF,$FFFF);
    canvas.Rectangle(0,0,image.Width-1,image.Height-1);
    pr^.GLControlInfo.SetLock();
    try
      pr^.Ftexture2D.bind();
      pr^.Ftexture2D.load(image.Width,image.Height,GL_RGBA,GL_RGBA,image.PixelData);
      pr^.Ftexture2D.unBind();
    finally
      pr^.GLControlInfo.SetUnLock();
    end;
  finally
    FreeAndNil(canvas);
    FreeAndNil(image);
  end;
  EndThread(0);
end;

function threadPaintForm(pform: pointer) : ptrint;
var
  plane:TGGUIPlane;
  image:TLazIntfImage;
  rgba: TRawImageDescription;
  canvas:TFPImageCanvas;
  sizePlane:TGVector3f;
  pr:PGGUIRenderParamsPlane;
begin
  pr:=PGGUIRenderParamsPlane(pform);
  plane:=TGGUIPlane(pr^.GUIObject);
  sizePlane:=plane.GetSize();
  image:=TLazIntfImage.Create(0,0);
  try
    rgba.Init_BPP32_R8G8B8A8_BIO_TTB(0,0);
    image.DataDescription:=rgba;
    image.Width:=trunc(sizePlane[0]);
    image.Height:=trunc(sizePlane[1]);
    canvas:=TFPImageCanvas.create(image);
    canvas.Brush.FPColor:=FPColor($E0FF,$E0FF,$E0FF,$FFFF);
    canvas.Pen.FPColor:=FPColor($FFFF,$FFFF,$FFFF,$FFFF);
    canvas.Rectangle(0,0,image.Width-1,image.Height-1);
    canvas.Brush.FPColor:=FPColor($70FF,$70FF,$70FF,$FFFF);
    canvas.Rectangle(0,0,image.Width-1,18);

    pr^.GLControlInfo.SetLock();
    try
      pr^.Ftexture2D.bind();
      pr^.Ftexture2D.load(image.Width,image.Height,GL_RGBA,GL_RGBA,image.PixelData);
      pr^.Ftexture2D.unBind();
    finally
      pr^.GLControlInfo.SetUnLock();
    end;
  finally
    FreeAndNil(canvas);
    FreeAndNil(image);
  end;
  EndThread(0);
end;


