unit graphica_gldriveinfo;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, syncobjs, fgl, opengraphicscontrol;

type

   TGGLControl=TGOpenGLControl;
  { TGGLControlInfo }

  TGGLControlInfo = class
  private
    FLock:TCriticalSection;
    FGLControl:TGGLControl;
    FTerminated:Boolean;

  public
    constructor Create(w:TGGLControl);
    destructor Destroy();override;
    procedure SetLock();inline;
    procedure SetUnLock();inline;

    procedure Terminate();
    property Lock:TCriticalSection read FLock;
    property GLControl:TGGLControl read FGLControl;
    property Terminated:Boolean read FTerminated;
  end;


type
  TGLRenderObjects = class
    GLDirveInfo:TGGLControlInfo;
  end;

  TGLRenderMap = class(specialize TFPGMap <Pointer, TGLRenderObjects>)

  end;


implementation

{ TGGLControlInfo }

constructor TGGLControlInfo.Create(w: TGGLControl);
begin
  FGLControl:=w;
  FLock:=TCriticalSection.Create;
  FTerminated:=false;
end;

destructor TGGLControlInfo.Destroy;
begin
  FreeAndNil(FLock);
  inherited Destroy;
end;

procedure TGGLControlInfo.SetLock;
begin
  FLock.Enter;
  FGLControl.MakeCurrent();
end;

procedure TGGLControlInfo.SetUnLock;
begin
  FGLControl.ReleaseContext();
  FLock.Leave;
end;

procedure TGGLControlInfo.Terminate;
begin
  FTerminated:=true;
end;

end.

