unit graphica_glplane;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, gl, graphica_vector, graphica_globject,
  graphica_gltexture, graphica_glrenderinfo,graphica_glshader;


{$i graphica_glplane_shaders.inc}

  function gl_init_panel_list():GLuint;
  procedure gl_draw_panel_list(id:GLuint);inline;
  procedure gl_close_panel_list(id:GLuint);inline;

implementation
uses GLext;


function gl_init_panel_list():GLuint;
begin
  Result:=glGenLists(1);
  glNewList(Result, GL_COMPILE);
  glBegin(GL_QUADS);
      glColor3f(1.0, 0.0, 0.0);
      glTexCoord2f(0.0, 1.0);
      glVertex3f(-0.5, 0.5, 0.0);  // Слева вверху
      glTexCoord2f(1.0, 1.0);
      glVertex3f( 0.5, 0.5, 0.0);  // Справа вверху
      glTexCoord2f(1.0, 0.0);
      glVertex3f( 0.5,-0.5, 0.0);  // Справа внизу
      glTexCoord2f(0.0, 0.0);
      glVertex3f(-0.5,-0.5, 0.0);  // Слева внизу
  glEnd();
  glEndList();
end;

procedure gl_draw_panel_list(id: GLuint);
begin
  glCallList(id);
end;

procedure gl_close_panel_list(id: GLuint);
begin
  glDeleteLists(id,1);
end;


end.

