unit graphica_glrenderinfo;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, gl, graphica_gltexture, graphica_glview,
  graphica_gldriveinfo, opengraphicscontrol, graphica_glselect,
  graphica_glshader, graphica_guistyle;

type

  { TGRenderInfo }

  TGRenderInfo = class
  private
    FGLControlInfo:TGGLControlInfo;
    FView:TGGLView;
    FStyle:TGGUIStyle;
    FSelectMode:Boolean;
    FSelectDriver:TGLSelect;
    FGLQuardListID:GLuint;
    FGLStencilMask:GLuint;
  public
    constructor Create(w:TGOpenGLControl;QuardListID:GLuint);
    destructor Destroy();override;



    property GLControlInfo:TGGLControlInfo read FGLControlInfo;
    property View:TGGLView read FView;
    property SelectMode:Boolean read FSelectMode write FSelectMode;
    property SelectDriver:TGLSelect read FSelectDriver;
    property Style:TGGUIStyle read FStyle;
    property GLQuardListID:GLuint read FGLQuardListID;
    property GLStencilMask:GLuint read FGLStencilMask write FGLStencilMask;
  end;


implementation

{ TGRenderInfo }

constructor TGRenderInfo.Create(w: TGOpenGLControl; QuardListID: GLuint);
begin
  FView:=TGGLView.Create();
  FGLControlInfo:=TGGLControlInfo.Create(w);
  FSelectDriver:=TGLSelectColorList.Create();
  FStyle:=TGGUIStyle.Create();
  FGLQuardListID:=QuardListID;
  FGLStencilMask:=0;
end;

destructor TGRenderInfo.Destroy;
begin
  FreeAndNil(FStyle);
  FreeAndNil(FSelectDriver);
  FreeAndNil(FView);
  FreeAndNil(FGLControlInfo);
  inherited Destroy;
end;

end.

