unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs,
  opengraphicscontrol, graphica_globject;

type

  { TForm1 }

  TForm1 = class(TForm)
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    FOGL:TGOpenGLControl;
    procedure GOnInitGL(self:TObject);
    procedure OnOGLPaint(Sender: TObject);
    procedure OnResize(Sender: TObject);
    procedure OnMouseMove(Sender: TObject; Shift: TShiftState;
                              X, Y: Integer);
    procedure OnMouseUp(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
    procedure OnMouseDown(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
  public

  end;

var
  Form1: TForm1;
  RootObjects:TGGLObject;

implementation
uses graphica_glview, graphica_glplane, graphica_glrenderinfo,
  graphica_guivisualcomponents,graphica_glshader,
  graphica_gldriveinfo, graphica_guidrive,Unit2;
{$R *.lfm}

var
  GUIDrive:TGGUIDrive;
  openglThreadID:TThreadID;

  p0:TGGUIForm;
  p1:TGGUIForm;

function openglThread(openglcontrol: pointer) : ptrint;
var
  rI:TGRenderInfo;
begin
  rI:=TGRenderInfo(openglcontrol);
  while not rI.GLControlInfo.Terminated do begin
    rI.GLControlInfo.GLControl.Invalidate;
    Sleep(30);
  end;
  EndThread();
end;

{ TForm1 }

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  GUIDrive.RenderInfo.GLControlInfo.Terminate();
  WaitForThreadTerminate(openglThreadID,5000);
  FreeAndNil(GUIDrive);
  CloseAction:=caFree;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  openglThreadID:=0;
  FOGL:=TGOpenGLControl.Create(self);
  FOGL.Parent:=Self;
  FOGL.Align:=alClient;
  FOGL.OnInitGL:=@GOnInitGL;
  FOGL.OnPaint:=@OnOGLPaint;
  FOGL.OnResize:=@OnResize;
  FOGL.OnMouseMove:=@OnMouseMove;
  FOGL.OnMouseDown:=@OnMouseDown;
  FOGL.OnMouseUp:=@OnMouseUp;
  RootObjects:=TGGLObject.Create();

end;

procedure TForm1.FormShow(Sender: TObject);
begin
//   Form2.Show;

end;

procedure TForm1.GOnInitGL(self: TObject);
begin
  GUIDrive:=TGGUIDrive.create(RootObjects,FOGL,gl_init_panel_list());
  GUIDrive.RenderInfo.View.setBackgroundColor(0,0,0,1);
 // GUIDrive.renderInfo.View.setOrtho(-50,50,-50,50,0,1);
  GUIDrive.RenderInfo.View.atLook(0,0,-10,0,0,0,0,1,0);
  p0:=TGGUIForm.Create(RootObjects);
  p0.SetSize(150,150,1);
  p0.Alpha:=0.2;
  p0.Visible:=true;
  p0.JoinRenderParams(GUIDrive.RenderInfo.GLControlInfo);

  p1:=TGGUIForm.Create(RootObjects);
  p1.SetSize(150,150,1);
  p1.Alpha:=1;
  p1.Visible:=true;
  p1.JoinRenderParams(GUIDrive.RenderInfo.GLControlInfo);

  openglThreadID:=BeginThread(@openglThread,Pointer(GUIDrive.RenderInfo));
  p0.Paint();
  p1.Paint();
end;

procedure TForm1.OnOGLPaint(Sender: TObject);
begin
   GUIDrive.RenderInfo.GLControlInfo.SetLock();
   GUIDrive.RenderInfo.View.drawGLViewport();
   GUIDrive.RenderInfo.View.drawGLClear();

   GUIDrive.select();
   RootObjects.Render(GUIDrive.RenderInfo);
   GUIDrive.RenderInfo.View.drawGLViewport();
   GUIDrive.RenderInfo.View.drawGLClear();
   GUIDrive.render();

   FOGL.SwapBuffers;
   GUIDrive.RenderInfo.GLControlInfo.SetUnLock();
end;

procedure TForm1.OnResize(Sender: TObject);
begin
  GUIDrive.RenderInfo.View.setViewPort(0,0,Width,Height);
  GUIDrive.RenderInfo.View.setOrtho2d(Width,Height,0,100);
end;

procedure TForm1.OnMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer
  );
begin
  GUIDrive.mousemove(Shift,x,y);
end;

procedure TForm1.OnMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  GUIDrive.mouseup(Button,Shift,X,Y);
end;

procedure TForm1.OnMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  GUIDrive.mousedown(Button,Shift,X,Y);
end;

end.

