unit Unit2;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs,
  opengraphicscontrol;

type

  { TForm2 }

  TForm2 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    FOGL:TGOpenGLControl;
    procedure GOnInitGL(self:TObject);
    procedure OnOGLPaint(Sender: TObject);
    procedure OnResize(Sender: TObject);

  public

  end;

var
  Form2: TForm2;

implementation
uses graphica_glview, graphica_glplane, graphica_glrenderinfo,
  graphica_globject,graphica_guivisualcomponents,graphica_glshader,
  graphica_gldriveinfo, Unit1;

{$R *.lfm}

var
  renderInfo:TGRenderInfo;
  p0:TGGUIPlane;

function openglThread(openglcontrol: pointer) : ptrint;
var
  rI:TGRenderInfo;
begin
  rI:=TGRenderInfo(openglcontrol);
  while not rI.GLControlInfo.Terminated do begin
    rI.GLControlInfo.Lock.Enter;
    try
      rI.GLControlInfo.GLControl.Invalidate;
    finally
      rI.GLControlInfo.Lock.Leave;
    end;
    Sleep(50);
  end;
end;

{ TForm2 }

procedure TForm2.FormCreate(Sender: TObject);
begin
  FOGL:=TGOpenGLControl.Create(self);
  FOGL.Parent:=Self;
  FOGL.Align:=alClient;
  FOGL.OnInitGL:=@GOnInitGL;
  FOGL.OnPaint:=@OnOGLPaint;
  FOGL.OnResize:=@OnResize;

end;

procedure TForm2.GOnInitGL(self: TObject);
begin
  gl_init_panel_list();
  renderInfo:=TGRenderInfo.Create(FOGL,gl_init_panel_list());
  renderInfo.View.setBackgroundColor(0,0,0,1);
  renderInfo.View.atLook(0,0,-1,0,0,0,0,1,0);
  p0:=TGGUIPlane.Create(RootObjects);
  p0.SetSize(50,50,1);
  p0.Alpha:=0.5;
  p0.JoinRenderParams(renderInfo.GLControlInfo);
  BeginThread(@openglThread,Pointer(renderInfo));
  p0.Paint();
end;

procedure TForm2.OnOGLPaint(Sender: TObject);
begin
  renderInfo.View.drawGLViewport();
  renderInfo.View.drawGLClear();

 // RootObject.Render(renderInfo);
  FOGL.SwapBuffers;
end;

procedure TForm2.OnResize(Sender: TObject);
begin
  renderInfo.View.setViewPort(0,0,Width,Height);
  renderInfo.View.setOrtho2d(Width,Height,0,1);
end;

end.

